Index: /main/waeup.kofa/trunk/src/waeup/kofa/browser/templates/fileupload.pt
===================================================================
--- /main/waeup.kofa/trunk/src/waeup/kofa/browser/templates/fileupload.pt	(revision 13937)
+++ /main/waeup.kofa/trunk/src/waeup/kofa/browser/templates/fileupload.pt	(revision 13938)
@@ -23,5 +23,6 @@
 				<div class="btn btn-default btn-file" i18n:translate="">
           Select new file&hellip;
-          <input type="file" tal:attributes="name viewlet/input_name" />
+          <input i18n:name="input_name"
+                 type="file" tal:attributes="name viewlet/input_name" />
         </div>
 			</div>
Index: /main/waeup.kofa/trunk/src/waeup/kofa/students/browser.py
===================================================================
--- /main/waeup.kofa/trunk/src/waeup/kofa/students/browser.py	(revision 13937)
+++ /main/waeup.kofa/trunk/src/waeup/kofa/students/browser.py	(revision 13938)
@@ -3090,8 +3090,6 @@
 
     def label(self):
-        session = academic_sessions_vocab.getTerm(
-            self.current_academic_session).title
         return '%s tickets in academic session %s' % (
-            self.context.code, session)
+            self.context.code, self.session_title)
 
     def _searchCatalog(self, session):
@@ -3133,4 +3131,6 @@
             self.redirect(self.url(self.context))
             return
+        self.session_title = academic_sessions_vocab.getTerm(
+            self.current_academic_session).title
         self.tickets = self._searchCatalog(self.current_academic_session)
         editable_tickets = [
@@ -3184,4 +3184,6 @@
                     'updated (only integers are allowed): %s.' % error.strip(', ')),
                 type="danger")
+            return
+        self.flash(_('You successfully updated course results.'))
         return
 
Index: /main/waeup.kofa/trunk/src/waeup/kofa/students/browser_templates/editscorespage.pt
===================================================================
--- /main/waeup.kofa/trunk/src/waeup/kofa/students/browser_templates/editscorespage.pt	(revision 13937)
+++ /main/waeup.kofa/trunk/src/waeup/kofa/students/browser_templates/editscorespage.pt	(revision 13938)
@@ -3,6 +3,8 @@
   You can either update scores by importing a csv file
   (press 'Help' for further information) or by
-  changing score values in the table below. Only scores of students
-  in state 'courses validated' and current academic session
+  changing score values in the table below. Only scores
+  of students in state 'courses validated' and current session
+  <span  i18n:name="current_academic_session"
+         tal:replace="view/session_title"></span>
   can be modified.
 </p>
@@ -13,6 +15,6 @@
     <div class="input-group-btn">
       <div class="btn btn-default btn-file" i18n:translate="">
-        Select file&hellip;
-        <input type="file" name="uploadfile:file" />
+        Select csv file&hellip;
+        <input type="file" name="uploadfile:file" i18n:name="input_file"/>
       </div>
     </div>
@@ -38,9 +40,27 @@
                   aria-hidden="true">&times;</button>
           <h4 class="modal-title" id="myModalLabel" i18n:translate="">
-            Instructions for File Upload
+            Step-by-step instructions
           </h4>
         </div>
         <div class="modal-body" i18n:translate="lecturer_help">
-          ...
+          <ol>
+            <li>Download csv file.</li>
+            <li>Open csv file in a text editor or in a spreadsheet
+                programme (Excel or Calc).</li>
+            <li>Edit course results only. Do not modify other entries.
+                Do not remove or add columns. Do not add rows.</li>
+            <li>Save file in same format (csv).
+                Do not switch to any other format (xls, xlsx or ods).</li>
+            <li>Select same file for upload and press the blue 'Update ...'
+                button.</li>
+            <li>The values in the table will be updated. Spot-check if
+                the values in the table correspond with the values in
+                your file.</li>
+            <li>Ready</li>
+          </ol>
+          <strong>Note:</strong>
+          Only course results of students which are in
+          state 'courses validated' and in current academic session
+          can be modified. Additional data will just be ignored.
         </div>
       </div><!-- /.modal-content -->