Index: /main/waeup.aaue/trunk/src/waeup/aaue/students/browser.py
===================================================================
--- /main/waeup.aaue/trunk/src/waeup/aaue/students/browser.py	(revision 13938)
+++ /main/waeup.aaue/trunk/src/waeup/aaue/students/browser.py	(revision 13939)
@@ -26,5 +26,5 @@
 from waeup.kofa.browser.layout import UtilityView
 from waeup.kofa.widgets.datewidget import FriendlyDatetimeDisplayWidget
-from waeup.kofa.interfaces import IKofaUtils
+from waeup.kofa.interfaces import IKofaUtils, academic_sessions_vocab
 from waeup.kofa.students.interfaces import IStudentsUtils, IStudent
 from waeup.kofa.students.workflow import PAID, REGISTERED
@@ -572,4 +572,6 @@
             self.redirect(self.url(self.context))
             return
+        self.session_title = academic_sessions_vocab.getTerm(
+            self.current_academic_session).title
         self.tickets = self._searchCatalog(self.current_academic_session)
         editable_tickets = [
@@ -633,4 +635,6 @@
               'Only integers are allowed.' % error.strip(', ')),
               type="danger")
+            return
+        self.flash(_('You successfully updated course results.'))
         return
 
Index: /main/waeup.aaue/trunk/src/waeup/aaue/students/browser_templates/editscorespage.pt
===================================================================
--- /main/waeup.aaue/trunk/src/waeup/aaue/students/browser_templates/editscorespage.pt	(revision 13938)
+++ /main/waeup.aaue/trunk/src/waeup/aaue/students/browser_templates/editscorespage.pt	(revision 13939)
@@ -1,8 +1,10 @@
-<p  i18n:domain="waeup.kofa" i18n:translate="edit_scores_info">
+<p i18n:domain="waeup.kofa" i18n:translate="edit_scores_info">
   This page helps you to update your students' course results.
   You can either update scores and CAs by importing a csv file
   (press 'Help' for further information) or by
   changing score or CA values in the table below. Only scores and CAs
-  of students in state 'courses validated' and current academic session
+  of students in state 'courses validated' and current session
+  <span  i18n:name="current_academic_session"
+         tal:replace="view/session_title"></span>
   can be modified.
 </p>
@@ -13,6 +15,6 @@
     <div class="input-group-btn">
       <div class="btn btn-default btn-file" i18n:translate="">
-        Select file&hellip;
-        <input type="file" name="uploadfile:file" />
+        Select csv file&hellip;
+        <input type="file" name="uploadfile:file" i18n:name="input_file"/>
       </div>
     </div>
@@ -42,5 +44,23 @@
         </div>
         <div class="modal-body" i18n:translate="lecturer_help">
-          ...
+          <ol>
+            <li>Download csv file.</li>
+            <li>Open csv file in a text editor or in a spreadsheet
+                programme (Excel or Calc).</li>
+            <li>Edit course results only. Do not modify other entries.
+                Do not remove or add columns. Do not add rows.</li>
+            <li>Save file in same format (csv).
+                Do not switch to any other format (xls, xlsx or ods).</li>
+            <li>Select same file for upload and press the blue 'Update ...'
+                button.</li>
+            <li>The values in the table will be updated. Spot-check if
+                the values in the table correspond with the values in
+                your file.</li>
+            <li>Ready</li>
+          </ol>
+          <strong>Note:</strong>
+          Only course results of students which are in
+          state 'courses validated' and in current academic session
+          can be modified. Additional data will just be ignored.
         </div>
       </div><!-- /.modal-content -->
@@ -54,4 +74,5 @@
     <tr>
       <th i18n:translate="">Matric No.</th>
+      <th i18n:translate="">Reg. No.</th>
       <th i18n:translate="">Fullname</th>
       <th i18n:translate="">Status</th>
@@ -65,4 +86,5 @@
     <tr tal:repeat="ticket view/tickets">
       <td tal:content="ticket/student/matric_number">MATRIC_NUMBER</td>
+      <td tal:content="ticket/student/reg_number">REG_NUMBER</td>
       <td tal:content="ticket/student/display_fullname">FULLNAME</td>
       <td tal:content="ticket/student/translated_state">STATE</td>