Index: main/waeup.kofa/trunk/docs/source/userdocs/students/browser.rst
===================================================================
--- main/waeup.kofa/trunk/docs/source/userdocs/students/browser.rst	(revision 13947)
+++ main/waeup.kofa/trunk/docs/source/userdocs/students/browser.rst	(revision 13948)
@@ -69,5 +69,5 @@
 .. seealso::
 
-  :ref:`Clearance Handling Doctests <test_handle_clearance>`
+  :ref:`Clearance Handling Tests <test_handle_clearance>`
 
 
@@ -275,5 +275,5 @@
 .. seealso::
 
-  :ref:`Course List Validation Doctests <test_handle_courses>`
+  :ref:`Course List Validation Tests <test_handle_courses>`
 
 
@@ -284,10 +284,8 @@
 
 Lecturers cannot access student records directly. They don't have
-access to the students section. Instead, lecturers go to their course
-in the academic section and view or export lists of students who
-attended the course, either in a previous or in the current session.
-They do also see an 'Update scores' link button which opens the
-`EditScoresPage` if score editing is enabled for that department
-(`IDepartment.score_editing_disabled`) and
+access to the students section. Instead, lecturers go to their
+course in the academic section and click the 'Update scores' button
+which opens the `EditScoresPage` if score editing is enabled for
+that department (`IDepartment.score_editing_disabled`) and
 `IConfigurationContainer.current_academic_session` has been set on
 the portal's configuration page. The `EditScoresPage` lists all
@@ -298,7 +296,22 @@
 :py:meth:`CourseTicket.editable_by_lecturer<waeup.kofa.students.studylevel.CourseTicket.editable_by_lecturer>`.
 
+There are two options to edit course results. (1) Scores in course tickets can be changed by editing its values in the table and pressing the 'Update scores from table' button below. Scores can be cleared by removing the respective values. Lecturers have to be online during this process.(2) Alternatively, lecturers can download a csv file, edit scores in this csv file offline and upload the same file when they are online again. This procedure is explained in step-by-step instructions which show up when pressing the yellow 'Help' button:
+
+.. admonition:: Help
+
+  **Step-by-step instructions**
+
+  1. Download csv file.
+  2. Open csv file in a text editor or in a spreadsheet programme (Excel or Calc).
+  3. Edit course results only. Do not modify other entries. Do not remove or add columns. Do not add rows.
+  4. Save file in same format (csv). Do not switch to any other format (xls, xlsx or ods).
+  5. Select same file for upload and press the blue 'Update ...' button.
+  6. The values in the table will be updated. Spot-check if the values in the table correspond with the values in your file.
+
+  Note: Only course results of students which are in state 'courses validated' and in current academic session can be modified. Additional data will just be ignored.
+
 .. seealso::
 
-  :ref:`Batch Editing Scores Doctests <test_batch_editing_scores>`
+  :ref:`Batch Editing Scores Tests <test_batch_editing_scores>`
 
 
@@ -378,3 +391,3 @@
 .. seealso::
 
-  :ref:`Bed Space Booking Doctests <test_handle_accommodation>`
+  :ref:`Bed Space Booking Tests <test_handle_accommodation>`
Index: main/waeup.kofa/trunk/docs/source/userdocs/testing.rst
===================================================================
--- main/waeup.kofa/trunk/docs/source/userdocs/testing.rst	(revision 13947)
+++ main/waeup.kofa/trunk/docs/source/userdocs/testing.rst	(revision 13948)
@@ -220,10 +220,10 @@
 ---------------------------------
 
-This test can be found in
-`waeup.kofa.students.tests.test_browser.OfficerUITests`. The corresponding use
-case is described :ref:`elsewhere <batch_editing_scores>`.
-
-.. literalinclude:: ../../../src/waeup/kofa/students/tests/test_browser.py
-   :pyobject: OfficerUITests.test_handle_courses_by_lecturer
+These test can be found in
+`waeup.kofa.students.tests.test_browser.LecturerUITests`. The corresponding use
+cases are described :ref:`elsewhere <batch_editing_scores>`.
+
+.. literalinclude:: ../../../src/waeup/kofa/students/tests/test_browser.py
+   :pyobject: LecturerUITests
 
 .. _test_manage_hostels: