Index: main/waeup.kofa/trunk/src/waeup/kofa/applicants/tests/test_browser.py
===================================================================
--- main/waeup.kofa/trunk/src/waeup/kofa/applicants/tests/test_browser.py	(revision 13949)
+++ main/waeup.kofa/trunk/src/waeup/kofa/applicants/tests/test_browser.py	(revision 13950)
@@ -1447,11 +1447,12 @@
     layer = FunctionalLayer
 
-    def wait_for_export_job_completed(self):
+    def wait_for_export_jobs_completed(self):
         # helper function waiting until the current export job is completed
         manager = getUtility(IJobManager)
-        job_id = self.app['datacenter'].running_exports[0][0]
-        job = manager.get(job_id)
-        wait_for_result(job)
-        return job_id
+        job_ids = [i[0] for i in self.app['datacenter'].running_exports]
+        jobs = [manager.get(job_id) for job_id in job_ids]
+        for job in jobs:
+            wait_for_result(job)
+        return job_ids
 
     def test_applicants_in_container_export(self):
@@ -1460,23 +1461,31 @@
         self.browser.open(container_path)
         self.browser.getLink("Export applicants").click()
-        self.browser.getControl("Start new export").click()
-
-        # When the job is finished and we reload the page...
-        job_id = self.wait_for_export_job_completed()
+        self.browser.getControl("Start new exports").click()
+        job_ids = self.wait_for_export_jobs_completed()
+        # Two exports were created
+        self.assertEqual(len(self.app['datacenter'].running_exports), 2)
+       # When the jobs are finished and we reload the page...
         self.browser.open(container_path + '/exports')
-        # ... the csv file can be downloaded ...
-        self.browser.getLink("Download").click()
+        # ... the both csv files can be downloaded ...
+        self.browser.getLink("Download", index=0).click()
         self.assertEqual(self.browser.headers['content-type'],
             'text/csv; charset=UTF-8')
         self.assertTrue(
-            'filename="WAeUP.Kofa_applicants_%s.csv' % job_id in
+            'filename="WAeUP.Kofa_applicants_%s.csv' % job_ids[0] in
             self.browser.headers['content-disposition'])
-        self.assertEqual(len(self.app['datacenter'].running_exports), 1)
-        job_id = self.app['datacenter'].running_exports[0][0]
+        self.browser.open(container_path + '/exports')
+        self.browser.getLink("Download", index=1).click()
+        self.assertEqual(self.browser.headers['content-type'],
+            'text/csv; charset=UTF-8')
+        self.assertTrue(
+            'filename="WAeUP.Kofa_applicantpayments_%s.csv' % job_ids[1] in
+            self.browser.headers['content-disposition'])
         # ... and discarded
         self.browser.open(container_path + '/exports')
+        self.browser.getControl("Discard", index=0).click()
+        self.assertEqual(len(self.app['datacenter'].running_exports), 1)
         self.browser.getControl("Discard").click()
         self.assertEqual(len(self.app['datacenter'].running_exports), 0)
-        # Creation, downloading and discarding is logged
+        # Creation, downloading and discarding are logged
         logfile = os.path.join(
             self.app['datacenter'].storage, 'logs', 'datacenter.log')
@@ -1485,13 +1494,27 @@
             'zope.mgr - applicants.browser.ExportJobContainerJobStart - '
             'exported: applicants (%s), job_id=%s'
-            % (container_name_1, job_id) in logcontent
+            % (container_name_1, job_ids[0]) in logcontent
             )
         self.assertTrue(
             'zope.mgr - applicants.browser.ExportJobContainerDownload '
             '- downloaded: WAeUP.Kofa_applicants_%s.csv, job_id=%s'
-            % (job_id, job_id) in logcontent
+            % (job_ids[0], job_ids[0]) in logcontent
             )
         self.assertTrue(
             'zope.mgr - applicants.browser.ExportJobContainerOverview '
-            '- discarded: job_id=%s' % job_id in logcontent
+            '- discarded: job_id=%s' % job_ids[0] in logcontent
             )
+        self.assertTrue(
+            'zope.mgr - applicants.browser.ExportJobContainerJobStart - '
+            'exported: applicantpayments (%s), job_id=%s'
+            % (container_name_1, job_ids[1]) in logcontent
+            )
+        self.assertTrue(
+            'zope.mgr - applicants.browser.ExportJobContainerDownload '
+            '- downloaded: WAeUP.Kofa_applicantpayments_%s.csv, job_id=%s'
+            % (job_ids[1], job_ids[1]) in logcontent
+            )
+        self.assertTrue(
+            'zope.mgr - applicants.browser.ExportJobContainerOverview '
+            '- discarded: job_id=%s' % job_ids[1] in logcontent
+            )