Index: main/waeup.aaue/trunk/src/waeup/aaue/applicants/browser.py
===================================================================
--- main/waeup.aaue/trunk/src/waeup/aaue/applicants/browser.py	(revision 13976)
+++ main/waeup.aaue/trunk/src/waeup/aaue/applicants/browser.py	(revision 13977)
@@ -66,5 +66,5 @@
       )
 UG_OMIT_DISPLAY_FIELDS = OMIT_DISPLAY_FIELDS + (
-    'jamb_subjects_list',) + UG_OMIT_FIELDS
+    'jamb_subjects_list', 'master_sheet_number') + UG_OMIT_FIELDS
 UG_OMIT_PDF_FIELDS = UG_OMIT_DISPLAY_FIELDS + UG_OMIT_FIELDS + (
       'reg_number','alr_fname', 'alr_no', 'alr_date',
@@ -80,4 +80,12 @@
     'jamb_reg_number',
     'aggregate',
+
+    'firstname',
+    'middlename',
+    'lastname',
+    'sex',
+    'lga',
+    'course1',
+    'master_sheet_number',
     )
 
@@ -101,5 +109,5 @@
     'scd_sit_type',
     'scd_sit_results',
-    'programme_type',
+    #'programme_type',
     'jamb_age',
     'jamb_subjects',
Index: main/waeup.aaue/trunk/src/waeup/aaue/applicants/browser_templates/applicanteditpage.pt
===================================================================
--- main/waeup.aaue/trunk/src/waeup/aaue/applicants/browser_templates/applicanteditpage.pt	(revision 13976)
+++ main/waeup.aaue/trunk/src/waeup/aaue/applicants/browser_templates/applicanteditpage.pt	(revision 13977)
@@ -100,52 +100,54 @@
   </div>
 
-  <br /><br />
-  <h3 i18n:translate="">
-      Payment Tickets
-  </h3>
+  <tal:payments condition="view/display_payments">
+    <br /><br />
+    <h3 i18n:translate="">
+        Payment Tickets
+    </h3>
 
-  <table i18n:domain="waeup.kofa" class="table table-condensed">
-    <thead>
-    <tr>
-      <th>&nbsp;</th>
-      <th i18n:translate="">Payment Id</th>
-      <th i18n:translate="">Creation Date</th>
-      <th i18n:translate="">Payment Date</th>
-      <th i18n:translate="">Category</th>
-      <th i18n:translate="">Item</th>
-      <th i18n:translate="">State</th>
-    </tr>
-    </thead>
-    <tbody>
-      <tr tal:repeat="cl context/values">
-         <td>
-          <input type="checkbox"
-    		 name="val_id"
-    		 tal:attributes="value cl/__name__"
-         tal:condition="python: not view.unremovable(cl)" />
-        </td>
-        <td> <a tal:attributes="href python:view.url(cl)">
-        <span tal:content="cl/p_id">PID</span></a></td>
-        <td tal:content="python: layout.formatDatetime(cl.creation_date)">CREATION DATE</td>
-        <td tal:content="python: layout.formatDatetime(cl.payment_date)">PAYMENT DATE</td>
-      <td tal:content ="cl/category">CATEGORY</td>
-      <td tal:content ="cl/display_item">ITEM</td>
-      <td tal:content ="cl/p_state_title">STATE</td>
+    <table i18n:domain="waeup.kofa" class="table table-condensed">
+      <thead>
+      <tr>
+        <th>&nbsp;</th>
+        <th i18n:translate="">Payment Id</th>
+        <th i18n:translate="">Creation Date</th>
+        <th i18n:translate="">Payment Date</th>
+        <th i18n:translate="">Category</th>
+        <th i18n:translate="">Item</th>
+        <th i18n:translate="">State</th>
       </tr>
-    </tbody>
-  </table>
+      </thead>
+      <tbody>
+        <tr tal:repeat="cl context/values">
+           <td>
+            <input type="checkbox"
+      		 name="val_id"
+      		 tal:attributes="value cl/__name__"
+           tal:condition="python: not view.unremovable(cl)" />
+          </td>
+          <td> <a tal:attributes="href python:view.url(cl)">
+          <span tal:content="cl/p_id">PID</span></a></td>
+          <td tal:content="python: layout.formatDatetime(cl.creation_date)">CREATION DATE</td>
+          <td tal:content="python: layout.formatDatetime(cl.payment_date)">PAYMENT DATE</td>
+        <td tal:content ="cl/category">CATEGORY</td>
+        <td tal:content ="cl/display_item">ITEM</td>
+        <td tal:content ="cl/p_state_title">STATE</td>
+        </tr>
+      </tbody>
+    </table>
 
-  <div tal:condition="view/availableActions">
-    <span tal:repeat="action view/actions"
-          tal:omit-tag="">
-      <input tal:condition="python:action.label in view.display_actions[1]"
-             tal:replace="structure action/render"/>
-    </span>
-  </div>
-  <br />
-  <p i18n:translate="" tal:condition="context/special">
-    <strong>Notice:</strong> If you need to pay for another service,
-    select the corresponding special application category above,
-    click 'Save' and then 'Add online payment ticket' again.
-  </p>
+    <div tal:condition="view/availableActions">
+      <span tal:repeat="action view/actions"
+            tal:omit-tag="">
+        <input tal:condition="python:action.label in view.display_actions[1]"
+               tal:replace="structure action/render"/>
+      </span>
+    </div>
+    <br />
+    <p i18n:translate="" tal:condition="context/special">
+      <strong>Notice:</strong> If you need to pay for another service,
+      select the corresponding special application category above,
+      click 'Save' and then 'Add online payment ticket' again.
+    </p>
+  </tal:payments>
 </form>
Index: main/waeup.aaue/trunk/src/waeup/aaue/applicants/interfaces.py
===================================================================
--- main/waeup.aaue/trunk/src/waeup/aaue/applicants/interfaces.py	(revision 13976)
+++ main/waeup.aaue/trunk/src/waeup/aaue/applicants/interfaces.py	(revision 13977)
@@ -60,9 +60,9 @@
     """
 
-    programme_type = schema.Choice(
-        title = _(u'Programme Type'),
-        vocabulary = programme_types_vocab,
-        required = False,
-        )
+    #programme_type = schema.Choice(
+    #    title = _(u'Programme Type'),
+    #    vocabulary = programme_types_vocab,
+    #    required = False,
+    #    )
 
     nationality = schema.Choice(
@@ -84,10 +84,14 @@
         required = False,
         )
-    jamb_reg_number = schema.TextLine(
-        title = _(u'JAMB Registration Number'),
-        required = False,
-        )
+    #jamb_reg_number = schema.TextLine(
+    #    title = _(u'JAMB Registration Number'),
+    #    required = False,
+    #    )
     jamb_score = schema.Int(
         title = _(u'Total JAMB Score'),
+        required = False,
+        )
+    jamb_subjects = schema.Text(
+        title = _(u'JAMB Subjects and Scores'),
         required = False,
         )
@@ -406,4 +410,12 @@
         required = False,
         )
+
+
+    master_sheet_number = schema.TextLine(
+        title = _(u'Master Sheet Number'),
+        required = False,
+        readonly = False,
+        )
+
     #screening_venue = schema.TextLine(
     #    title = _(u'Screening Venue'),
@@ -447,6 +459,6 @@
             raise Invalid(_("2nd choice course must differ from 1st choice course."))
 
-ICustomUGApplicant['programme_type'].order = IApplicantBaseData[
-    'reg_number'].order
+#ICustomUGApplicant['programme_type'].order = IApplicantBaseData[
+#    'reg_number'].order
 
 class ICustomPGApplicant(INigeriaPGApplicant):
@@ -628,9 +640,9 @@
     """
 
-    programme_type = schema.Choice(
-        title = _(u'Programme Type'),
-        vocabulary = programme_types_vocab,
-        required = True,
-        )
+    #programme_type = schema.Choice(
+    #    title = _(u'Programme Type'),
+    #    vocabulary = programme_types_vocab,
+    #    required = True,
+    #    )
 
     date_of_birth = FormattedDate(
@@ -640,6 +652,6 @@
         )
 
-ICustomUGApplicantEdit['programme_type'].order = ICustomUGApplicant[
-    'programme_type'].order
+#ICustomUGApplicantEdit['programme_type'].order = ICustomUGApplicant[
+#    'programme_type'].order
 ICustomUGApplicantEdit['date_of_birth'].order = ICustomUGApplicant[
     'date_of_birth'].order
Index: main/waeup.aaue/trunk/src/waeup/aaue/applicants/tests/test_applicantcopier.py
===================================================================
--- main/waeup.aaue/trunk/src/waeup/aaue/applicants/tests/test_applicantcopier.py	(revision 13976)
+++ main/waeup.aaue/trunk/src/waeup/aaue/applicants/tests/test_applicantcopier.py	(revision 13977)
@@ -49,5 +49,5 @@
         self.browser.getControl(name="form.lga").value = ['abia_aba_north']
         self.browser.getControl(name="form.course_admitted").value = ['CERT1']
-        self.browser.getControl(name="form.programme_type").value = ['regular']
+        #self.browser.getControl(name="form.programme_type").value = ['regular']
         # Date of birth is not required
         self.browser.getControl(name="form.date_of_birth").value = ''
Index: main/waeup.aaue/trunk/src/waeup/aaue/applicants/tests/test_browser.py
===================================================================
--- main/waeup.aaue/trunk/src/waeup/aaue/applicants/tests/test_browser.py	(revision 13976)
+++ main/waeup.aaue/trunk/src/waeup/aaue/applicants/tests/test_browser.py	(revision 13977)
@@ -56,6 +56,7 @@
         self.login()
         self.browser.open(self.edit_path)
-        self.fill_correct_values()
-        self.browser.getControl(name="form.programme_type").value = ['regular']
+        self.browser.getControl(name="form.date_of_birth").value = '09/09/1988'
+        self.browser.getControl(name="form.email").value = 'xx@yy.zz'
+        #self.browser.getControl(name="form.programme_type").value = ['regular']
         self.browser.getControl(name="form.nationality").value = ['NG']
         self.browser.getControl("Save").click()
Index: main/waeup.aaue/trunk/src/waeup/aaue/etranzact/tests.py
===================================================================
--- main/waeup.aaue/trunk/src/waeup/aaue/etranzact/tests.py	(revision 13976)
+++ main/waeup.aaue/trunk/src/waeup/aaue/etranzact/tests.py	(revision 13977)
@@ -255,4 +255,5 @@
     def setUp(self):
         super(EtranzactTestsApplicants, self).setUp()
+        self.applicantscontainer.application_fee = 200.0
         self.browser.addHeader('Authorization', 'Basic mgr:mgrpw')
         self.browser.open(self.manage_path)
@@ -261,5 +262,5 @@
         self.browser.getControl(name="transition").value = ['start']
         self.browser.getControl(name="form.nationality").value = ['NG']
-        self.browser.getControl(name="form.programme_type").value = ['direct']
+        #self.browser.getControl(name="form.programme_type").value = ['direct']
         self.browser.getControl("Save").click()
         self.browser.getControl("Add online").click()
Index: main/waeup.aaue/trunk/src/waeup/aaue/interswitch/tests.py
===================================================================
--- main/waeup.aaue/trunk/src/waeup/aaue/interswitch/tests.py	(revision 13976)
+++ main/waeup.aaue/trunk/src/waeup/aaue/interswitch/tests.py	(revision 13977)
@@ -58,5 +58,5 @@
         #IWorkflowState(self.student).setState('started')
         super(InterswitchTestsApplicants, self).fill_correct_values()
-        self.browser.getControl(name="form.programme_type").value = ['regular']
+        #self.browser.getControl(name="form.programme_type").value = ['regular']
         self.applicantscontainer.application_fee = 10000.0
         self.browser.getControl(name="form.nationality").value = ['NG']