Index: /main/kofacustom.nigeria/trunk/src/kofacustom/nigeria/applicants/export.py
===================================================================
--- /main/kofacustom.nigeria/trunk/src/kofacustom/nigeria/applicants/export.py	(revision 13978)
+++ /main/kofacustom.nigeria/trunk/src/kofacustom/nigeria/applicants/export.py	(revision 13979)
@@ -21,4 +21,5 @@
 from waeup.kofa.applicants.interfaces import IApplicantBaseData
 from waeup.kofa.applicants.export import ApplicantExporter
+from waeup.kofa.utils.helpers import iface_names
 from kofacustom.nigeria.applicants.interfaces import (
     INigeriaUGApplicant, INigeriaPGApplicant)
@@ -31,8 +32,10 @@
     # and attributes of the interfaces.
     fields = tuple(sorted(set(
-        INigeriaUGApplicant.names() +
-        INigeriaPGApplicant.names() +
-        IApplicantBaseData.names()
-        )))
+        iface_names(INigeriaUGApplicant) +
+        iface_names(INigeriaPGApplicant) +
+        iface_names(IApplicantBaseData)
+        ))) + (
+        'password', 'state', 'history', 'container_code', 'application_number',
+        'display_fullname', 'application_date')
 
     def mangle_value(self, value, name, context=None):
Index: /main/kofacustom.nigeria/trunk/src/kofacustom/nigeria/applicants/tests/test_browser.py
===================================================================
--- /main/kofacustom.nigeria/trunk/src/kofacustom/nigeria/applicants/tests/test_browser.py	(revision 13978)
+++ /main/kofacustom.nigeria/trunk/src/kofacustom/nigeria/applicants/tests/test_browser.py	(revision 13979)
@@ -432,28 +432,28 @@
         result = open(self.outfile, 'rb').read()
         self.assertMatches(result,
-            'aggregate,applicant_id,application_date,application_number,'
-            'container_code,course1,course2,course_admitted,date_of_birth,'
-            'display_fullname,email,emp2_end,emp2_position,emp2_reason,'
+            'aggregate,applicant_id,course1,course2,course_admitted,'
+            'date_of_birth,email,emp2_end,emp2_position,emp2_reason,'
             'emp2_start,emp_end,emp_position,emp_reason,emp_start,employer,'
             'employer2,firstname,fst_sit_date,fst_sit_fname,fst_sit_no,'
-            'fst_sit_results,fst_sit_type,history,hq_degree,hq_disc,'
-            'hq_fname,'
+            'fst_sit_results,fst_sit_type,hq_degree,hq_disc,hq_fname,'
             'hq_matric_no,hq_school,hq_session,hq_type,jamb_reg_number,'
-            'jamb_score,jamb_subjects,jamb_subjects_list,'
-            'lastname,lga,locked,middlename,'
-            'nationality,notice,nysc_lga,nysc_year,password,phone,'
-            'presently_inst,programme_type,reg_number,result_uploaded,scd_sit_date,'
-            'scd_sit_fname,scd_sit_no,scd_sit_results,scd_sit_type,'
-            'screening_date,screening_score,screening_venue,sex,special,'
-            'special_application,state,student_id,suspended,translated_state\r\n'
-
-            ',dp2011_654321,,654321,dp2011,CERT1,CERT1,CERT1,1981-02-04#,'
-            'Anna M. Tester,anna@sample.com,,,,,,,,,,,Anna,,,,,,'
-            '[u\'2015-07-06 11:21:22 WAT - Application initialized by system\']'
-            ',,,,,,,,,,Line 1++Line 2,"[\'english_language\', \'fine_art\']",'
+            'jamb_score,jamb_subjects,jamb_subjects_list,lastname,lga,'
+            'locked,middlename,nationality,notice,nysc_lga,nysc_year,'
+            'phone,presently_inst,programme_type,reg_number,result_uploaded,'
+            'scd_sit_date,scd_sit_fname,scd_sit_no,scd_sit_results,'
+            'scd_sit_type,screening_date,screening_score,screening_venue,'
+            'sex,special_application,student_id,suspended,password,state,'
+            'history,container_code,application_number,display_fullname,'
+            'application_date\r\n'
+
+            ',dp2011_654321,CERT1,CERT1,CERT1,1981-02-04#,'
+            'anna@sample.com,,,,,,,,,,,Anna,,,,,,,,,,,,,,,'
+            'Line 1++Line 2,"[\'english_language\', \'fine_art\']",'
             'Tester,,0,M.,NG,"Some notice\nin lines.",,,'
-            'any password,+234-123-12345#,,,123456,,,,,,,'
+            '+234-123-12345#,,,123456,,,,,,,'
             '"Saturday, 16th June 2012 2:00:00 PM",98,Exam Room,f,,,'
-            'initialized,,0,initialized\r\n')
+            '0,any password,initialized,'
+            '[u\'2016-06-23 10:58:23 WAT - Application initialized by system\'],'
+            'dp2011,654321,Anna M. Tester,\r\n')
         # We can import the same file if we ignore some columns.
         # Since the applicants_catalog hasn't been notified, the same
@@ -462,20 +462,20 @@
         result = processor.doImport(
             self.outfile,
-            ['aggregate','ignore_applicant_id','application_date','ignore_application_number',
-            'container_code','course1','course2','course_admitted','date_of_birth',
-            'display_fullname','email','emp2_end','emp2_position','emp2_reason',
+            [
+            'aggregate','ignore_applicant_id','course1','course2','course_admitted',
+            'date_of_birth','email','emp2_end','emp2_position','emp2_reason',
             'emp2_start','emp_end','emp_position','emp_reason','emp_start','employer',
             'employer2','firstname','fst_sit_date','fst_sit_fname','fst_sit_no',
-            'fst_sit_results','fst_sit_type','history','hq_degree','hq_disc',
-            'hq_fname',
+            'fst_sit_results','fst_sit_type','hq_degree','hq_disc','hq_fname',
             'hq_matric_no','hq_school','hq_session','hq_type','jamb_reg_number',
-            'jamb_score','jamb_subjects','jamb_subjects_list',
-            'lastname','lga','locked','middlename',
-            'nationality','notice','nysc_lga','nysc_year','password','phone',
-            'presently_inst','programme_type','reg_number','result_uploaded','scd_sit_date',
-            'scd_sit_fname','scd_sit_no','scd_sit_results','scd_sit_type',
-            'screening_date','screening_score','screening_venue','sex','special',
-            'special_application','state','student_id','suspended',
-            'translated_state'],
+            'jamb_score','jamb_subjects','jamb_subjects_list','lastname','lga',
+            'locked','middlename','nationality','notice','nysc_lga','nysc_year',
+            'phone','presently_inst','programme_type','reg_number','result_uploaded',
+            'scd_sit_date','scd_sit_fname','scd_sit_no','scd_sit_results',
+            'scd_sit_type','screening_date','screening_score','screening_venue',
+            'sex','special_application','student_id','suspended','password','state',
+            'ignore_history','container_code','ignore_application_number','display_fullname',
+            'application_date'
+            ],
             mode='create')
         num_succ, num_fail, finished_path, failed_path = result
@@ -491,20 +491,20 @@
         result = processor.doImport(
             self.outfile,
-            ['aggregate','ignore_applicant_id','application_date','ignore_application_number',
-            'ignore_container_code','course1','course2','course_admitted','date_of_birth',
-            'display_fullname','email','emp2_end','emp2_position','emp2_reason',
+            [
+            'aggregate','ignore_applicant_id','course1','course2','course_admitted',
+            'date_of_birth','email','emp2_end','emp2_position','emp2_reason',
             'emp2_start','emp_end','emp_position','emp_reason','emp_start','employer',
             'employer2','firstname','fst_sit_date','fst_sit_fname','fst_sit_no',
-            'fst_sit_results','fst_sit_type','history','hq_degree','hq_disc',
-            'hq_fname',
+            'fst_sit_results','fst_sit_type','hq_degree','hq_disc','hq_fname',
             'hq_matric_no','hq_school','hq_session','hq_type','jamb_reg_number',
-            'jamb_score','jamb_subjects','jamb_subjects_list',
-            'lastname','lga','locked','middlename',
-            'nationality','notice','nysc_lga','nysc_year','password','phone',
-            'presently_inst','programme_type','reg_number','result_uploaded','scd_sit_date',
-            'scd_sit_fname','scd_sit_no','scd_sit_results','scd_sit_type',
-            'screening_date','screening_score','screening_venue','sex','special',
-            'special_application','state','student_id','suspended',
-            'translated_state'],
+            'jamb_score','jamb_subjects','jamb_subjects_list','lastname','lga',
+            'locked','middlename','nationality','notice','nysc_lga','nysc_year',
+            'phone','presently_inst','programme_type','reg_number','result_uploaded',
+            'scd_sit_date','scd_sit_fname','scd_sit_no','scd_sit_results',
+            'scd_sit_type','screening_date','screening_score','screening_venue',
+            'sex','special_application','student_id','suspended','password','state',
+            'ignore_history','ignore_container_code','ignore_application_number',
+            'display_fullname','application_date'
+            ],
             mode='update')
         num_succ, num_fail, finished_path, failed_path = result