Index: main/kofacustom.skeleton/trunk/src/kofacustom/skeleton/applicants/tests/test_browser.py
===================================================================
--- main/kofacustom.skeleton/trunk/src/kofacustom/skeleton/applicants/tests/test_browser.py	(revision 13629)
+++ main/kofacustom.skeleton/trunk/src/kofacustom/skeleton/applicants/tests/test_browser.py	(revision 13983)
@@ -70,86 +70,4 @@
         return applicant
 
-    def test_export_reimport_all(self):
-        # we can export all applicants in a portal
-        # set values we can expect in export file
-        self.applicant = self.setup_applicant(self.applicant)
-        exporter = CustomApplicantExporter()
-        exporter.export_all(self.app, self.outfile)
-        result = open(self.outfile, 'rb').read()
-        self.assertMatches(result,
-            'aggregate,applicant_id,application_date,application_number,'
-            'container_code,course1,course2,course_admitted,date_of_birth,'
-            'display_fullname,email,emp2_end,emp2_position,emp2_reason,'
-            'emp2_start,emp_end,emp_position,emp_reason,emp_start,employer,'
-            'employer2,firstname,fst_sit_date,fst_sit_fname,fst_sit_no,'
-            'fst_sit_results,fst_sit_type,history,hq_degree,hq_disc,'
-            'hq_fname,hq_matric_no,hq_school,hq_session,hq_type,'
-            'jamb_reg_number,jamb_score,jamb_subjects,jamb_subjects_list,'
-            'lastname,lga,locked,middlename,nationality,notice,nysc_lga,'
-            'nysc_year,password,phone,presently_inst,programme_type,'
-            'reg_number,result_uploaded,scd_sit_date,scd_sit_fname,'
-            'scd_sit_no,scd_sit_results,scd_sit_type,screening_date,'
-            'screening_score,screening_venue,sex,special,special_application,'
-            'state,student_id,suspended,translated_state\r\n'
-            ',dp2011_654321,,654321,dp2011,CERT1,CERT1,CERT1,1981-02-04#,'
-            'Anna M. Tester,anna@sample.com,,,,,,,,,,,Anna,,,,,,'
-            '[u\'2016-01-17 08:15:47 WAT - Application initialized by system\']'
-            ',,,,,,,,,,,,Tester,,0,M.,NG,"Some notice\nin lines.",,,'
-            'any password,+234-123-12345#,,,123456,,,,,,,'
-            '"Saturday, 16th June 2012 2:00:00 PM",98,Exam Room,f,,,'
-            'initialized,,0,initialized\r\n')
-        # We can import the same file if we ignore some columns.
-        # Since the applicants_catalog hasn't been notified, the same
-        # record with same reg_number can be imported twice.
-        processor = CustomApplicantProcessor()
-        result = processor.doImport(
-            self.outfile,
-            ['aggregate','ignore_applicant_id','application_date','ignore_application_number',
-            'container_code','course1','course2','course_admitted','date_of_birth',
-            'ignore_display_fullname','email','emp2_end','emp2_position','emp2_reason',
-            'emp2_start','emp_end','emp_position','emp_reason','emp_start','employer',
-            'employer2','firstname','fst_sit_date','fst_sit_fname','fst_sit_no',
-            'fst_sit_results','fst_sit_type','ignore_history','hq_degree','hq_disc',
-            'hq_fname','hq_matric_no','hq_school','hq_session','hq_type',
-            'jamb_reg_number','jamb_score','jamb_subjects','jamb_subjects_list',
-            'lastname','lga','locked','middlename','nationality','notice','nysc_lga',
-            'nysc_year','password','phone','presently_inst','programme_type',
-            'reg_number','result_uploaded','scd_sit_date','scd_sit_fname',
-            'scd_sit_no','scd_sit_results','scd_sit_type','screening_date',
-            'screening_score','screening_venue','sex','ignore_special','special_application',
-            'state','student_id','suspended','ignore_translated_state'],
-            mode='create')
-        num_succ, num_fail, finished_path, failed_path = result
-        #content = open(failed_path).read()
-        self.assertEqual(num_succ,1)
-        self.assertEqual(num_fail,0)
-        # Now we ignore also the container_code and import the same file
-        # in update mode which means that INigeriaApplicantUpdateByRegNo
-        # is used for field conversion. applicant_id must be ignored
-        # too since the previous import has notified the applicants_catalog
-        # so that the portal 'knows' that reg_number is in use.
-        processor = CustomApplicantProcessor()
-        result = processor.doImport(
-            self.outfile,
-            ['aggregate','ignore_applicant_id','application_date','ignore_application_number',
-            'ignore_container_code','course1','course2','course_admitted','date_of_birth',
-            'ignore_display_fullname','email','emp2_end','emp2_position','emp2_reason',
-            'emp2_start','emp_end','emp_position','emp_reason','emp_start','employer',
-            'employer2','firstname','fst_sit_date','fst_sit_fname','fst_sit_no',
-            'fst_sit_results','fst_sit_type','ignore_history','hq_degree','hq_disc',
-            'hq_fname','hq_matric_no','hq_school','hq_session','hq_type',
-            'jamb_reg_number','jamb_score','jamb_subjects','jamb_subjects_list',
-            'lastname','lga','locked','middlename','nationality','notice','nysc_lga',
-            'nysc_year','password','phone','presently_inst','programme_type',
-            'reg_number','result_uploaded','scd_sit_date','scd_sit_fname',
-            'scd_sit_no','scd_sit_results','scd_sit_type','screening_date',
-            'screening_score','screening_venue','sex','ignore_special','special_application',
-            'state','student_id','suspended','ignore_translated_state'],
-            mode='update')
-        num_succ, num_fail, finished_path, failed_path = result
-        self.assertEqual(num_succ,1)
-        self.assertEqual(num_fail,0)
-        return
-
 class ApplicantsContainerUITests(ApplicantsFullSetup):
     # Tests for ApplicantsContainer class views and pages